import { AnswersQuestions, UsesAbilities } from '../actor';
import { Expectation } from '../expectations';
import { OneOrMany } from '../lists';
import { Performable } from '../performables';
import { Question } from '../question';
export declare class CompareNotes<S> implements Performable {
    private actual;
    private expect;
    private topic;
    static toSeeIf<A>(actual: Question<OneOrMany<A>>, expectation: Expectation<OneOrMany<A>>, topic: {
        toString: () => string;
    }): CompareNotes<A>;
    performAs(actor: UsesAbilities & AnswersQuestions): PromiseLike<void>;
    constructor(actual: Question<OneOrMany<S>>, expect: Expectation<OneOrMany<S>>, topic: string);
}
